#include "Vram.h"
#include "Chars.h"

extern byte[] MonoChars, ColorChars;

void InitVram()
{
    InitMonoChar(Vram_PatternGenerator, MonoChars, 64, 7);
    InitMonoChar(
        Vram_PatternGenerator + Char_Logo * CharHeight * 4,
        MonoChars + Char_Logo * CharHeight,
        16, 5
    );
    InitMonoChar(
        Vram_PatternGenerator + Char_Line_Normal * CharHeight * 4,
        MonoChars + Char_Line_Normal * CharHeight,
        8, 7
    );
    InitMonoChar(
        Vram_PatternGenerator + Char_Line_Red * CharHeight * 4,
        MonoChars + Char_Line_Normal * CharHeight,
        8, 2
    );
    InitColorChar(
        Vram_PatternGenerator + Char_Man * CharHeight * 4,
        ColorChars, Char_End - Char_Man
    );
}

void Put2S(word vram, ptr<byte> pChars)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, *pChars);
            ++pChars;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}


void Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            c += 2;
        }
        c -= 3;
        vram += VramRowSize - 2 * VramStep;
    }
}


void Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, Char_Space);
        }
        vram += VramRowSize - 2 * VramStep;
    }
}
