include "Vdp.inc"
include "Vram.inc"
include "Chars.inc"

ext WRTVRM
ext LDIRVM
ext RDVRM
ext FILVRM
ext WRTVDP


; void InitMonoChar(word vram, ptr<byte> p, byte count, byte color);
dseg
InitMonoChar_@Param3: public InitMonoChar_@Param3
    defb 0
cseg
InitMonoChar_: public InitMonoChar_
    push af | push hl | push de | push bc
        ld a,l | out (VdpPort+1),a
        ld a,h | or 40h | out (VdpPort+1),a
        ex de,hl
        do
            push bc
                ld c,CharHeight
                do
                    ld e,(hl) | inc hl
                    ld a,(InitMonoChar_@Param3)
                    ld d,a
                    ld b,4
                    do
                        bit 0,d
                        if nz
                            ld a,e
                        else
                            xor a
                        endif
                        out (VdpPort),a
                        srl d
                    dwnz
                    dec c
                while nz | wend
            pop bc
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void InitColorChar(word vram, ptr<byte> p, byte count);
cseg
InitColorChar_: public InitColorChar_
    push af | push hl | push de | push bc
        ld a,l | out (VdpPort+1),a
        ld a,h | or 40h | out (VdpPort+1),a
        ex de,hl
        do
            ld b,CharHeight*4
            do
                ld a,(hl) | inc hl
                out (VdpPort),a
            dwnz
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void ClearScreen();
cseg
ClearScreen_:
    public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram_PatternName
        ld bc,VramHeight*VramRowSize
        xor a
        call FILVRM

        ld hl,Vram_SpriteAttribute
        ld bc,64
        ld a,0c8h
        call FILVRM
    pop bc | pop hl | pop af
ret


; word VramAddress(byte x, byte y);
VramAddress_: public VramAddress_
    push de
        ld l,e
        ld h,0
        add hl,hl ;*2
        add hl,hl ;*4
        add hl,hl ;*8
        add hl,hl ;*16
        add hl,hl ;*32
        add hl,hl ;*64
        add a,a
        ld e,a
        ld d,0
        add hl,de
        ld de,Vram
        add hl,de
    pop de
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    push af
        di
            ld a,l | out (VdpPort+1),a
            ld a,h | or 40h | out (VdpPort+1),a
            ld a,e
            out (VdpPort),a
            nop | nop | nop
            xor a
            out (VdpPort),a
        ei
    pop af
    inc hl
    inc hl
ret


; word PrintC(word vram, byte c);
cseg
PrintC_: public PrintC_
    ex af,af'
        ld a,e
        sub ' '
        call WRTVRM
    ex af,af'
    inc hl
    inc hl
ret
